﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using Telerik.Windows.Controls;

namespace Q12012.WindowsPhone
{
    public partial class App : Application
    {
        /// <summary>
        /// Provides easy access to the root frame of the Phone Application.
        /// </summary>
        /// <returns>The root frame of the Phone Application.</returns>
        public PhoneApplicationFrame RootFrame { get; private set; }

        /// <summary>
        /// Constructor for the Application object.
        /// </summary>
        /// 

        //private static RadTrialFeatureReminder PaidFeatureReminder;
        //public static RadTrialFeatureReminder paidFeatureReminder
        //{
        //    get
        //    {
        //        if (PaidFeatureReminder != null)
        //        {
        //            return PaidFeatureReminder;
        //        }
        //        return new RadTrialFeatureReminder()
        //        {
        //            FreeUsageCount = 1,
        //            OccurrenceUsageCount = 2,
        //            AllowedTrialUsageCount = 7,
        //            FeatureId = 1
        //        };
        //    }
        //}

        //private static RadTrialApplicationReminder trialReminder;
        //public static RadTrialApplicationReminder TrialReminder
        //{
        //    get
        //    {
        //        if (trialReminder != null)
        //        {
        //            return trialReminder;
        //        }

        //        int option = 1;//for example purposes only. In real app you need only one configuration.

        //        if (option == 1) // configure trial reminders based on app usage only
        //        {
        //            return new RadTrialApplicationReminder()
        //            {
        //                AllowedTrialUsageCount = 3, // maximum number of app runs until trial is expired
        //                FreeUsageCount = 2, // number of app runs when no reminder will be displayed
        //                OccurrenceUsageCount = 1 // reminder will be displayed on every 3rd run after the free usage is over
        //            };
        //        }
        //        else if (option == 2) // configure trial reminder based on time period only
        //        {
        //            return new RadTrialApplicationReminder()
        //            {
        //                AllowedTrialPeriod = TimeSpan.FromDays(30), // maximum time before trial is over
        //                FreePeriod = TimeSpan.FromDays(20), // time period when no reminders are displayed
        //                OccurrencePeriod = TimeSpan.FromDays(3) // reminder will be displayed on 3 days after the last reminder (or later depending when user starts the app)
        //            };
        //        }
        //        // configure trial based on usage and period. Reminders will be displayed when either of the conditions are true.
        //        // So in this case trial will expire after 10 days or after 5 app usages. Free period is 5 days or 3 runs.
        //        else
        //        {
        //            return new RadTrialApplicationReminder()
        //            {
        //                AllowedTrialPeriod = TimeSpan.FromDays(10),
        //                FreePeriod = TimeSpan.FromDays(5),
        //                OccurrencePeriod = TimeSpan.FromDays(2),
        //                AllowedTrialUsageCount = 5,
        //                FreeUsageCount = 3,
        //                OccurrenceUsageCount = 1
        //            };
        //        }
        //    }
        //}



        public App()
        {

            RadDiagnostics diagnostics = new RadDiagnostics();
            diagnostics.ApplicationVersion = "1.0";
            diagnostics.ApplicationName = "Q1 2012 Webinar";
            diagnostics.EmailTo = "michael.crump@telerik.com";
            diagnostics.IncludeScreenshot = true;
            diagnostics.Init();


            // Global handler for uncaught exceptions. 
            UnhandledException += Application_UnhandledException;

            // Show graphics profiling information while debugging.
            if (System.Diagnostics.Debugger.IsAttached)
            {
                // Display the current frame rate counters.
                Application.Current.Host.Settings.EnableFrameRateCounter = true;

                // Show the areas of the app that are being redrawn in each frame.
                //Application.Current.Host.Settings.EnableRedrawRegions = true;

                // Enable non-production analysis visualization mode, 
                // which shows areas of a page that are being GPU accelerated with a colored overlay.
                //Application.Current.Host.Settings.EnableCacheVisualization = true;

              
            }

            // Standard Silverlight initialization
            InitializeComponent();

            // Phone-specific initialization
            InitializePhoneApplication();
        }

        // Code to execute when the application is launching (eg, from Start)
        // This code will not execute when the application is reactivated
        private void Application_Launching(object sender, LaunchingEventArgs e)
        {
           ApplicationUsageHelper.Init(1.0);
        }

        // Code to execute when the application is activated (brought to foreground)
        // This code will not execute when the application is first launched
        private void Application_Activated(object sender, ActivatedEventArgs e)
        {
        }

        // Code to execute when the application is deactivated (sent to background)
        // This code will not execute when the application is closing
        private void Application_Deactivated(object sender, DeactivatedEventArgs e)
        {
			// Ensure that required application state is persisted here.
        }

        // Code to execute when the application is closing (eg, user hit Back)
        // This code will not execute when the application is deactivated
        private void Application_Closing(object sender, ClosingEventArgs e)
        {
        }

        // Code to execute if a navigation fails
        private void RootFrame_NavigationFailed(object sender, NavigationFailedEventArgs e)
        {
            if (System.Diagnostics.Debugger.IsAttached)
            {
                // A navigation has failed; break into the debugger
                System.Diagnostics.Debugger.Break();
            }
        }

        // Code to execute on Unhandled Exceptions
        private void Application_UnhandledException(object sender, ApplicationUnhandledExceptionEventArgs e)
        {
            if (System.Diagnostics.Debugger.IsAttached)
            {
                // An unhandled exception has occurred; break into the debugger
                System.Diagnostics.Debugger.Break();
            }
        }

        #region Phone application initialization

        // Avoid double-initialization
        private bool phoneApplicationInitialized = false;

        // Do not add any additional code to this method
        private void InitializePhoneApplication()
        {
            if (phoneApplicationInitialized)
                return;

            // Create the frame but don't set it as RootVisual yet; this allows the splash
            // screen to remain active until the application is ready to render.
            RootFrame = new RadPhoneApplicationFrame();
            RootFrame.Navigated += CompleteInitializePhoneApplication;

            // Handle navigation failures
            RootFrame.NavigationFailed += RootFrame_NavigationFailed;

            // Ensure we don't initialize again
            phoneApplicationInitialized = true;
        }

        // Do not add any additional code to this method
        private void CompleteInitializePhoneApplication(object sender, NavigationEventArgs e)
        {
            // Set the root visual to allow the application to render
            if (RootVisual != RootFrame)
                RootVisual = RootFrame;

            // Remove this handler since it is no longer needed
            RootFrame.Navigated -= CompleteInitializePhoneApplication;
        }

        #endregion
    }
}
