﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using Telerik.Windows.Controls;

namespace Q12012.WindowsPhone.Demos
{
    public partial class LiveTileHelper : PhoneApplicationPage
    {
        public LiveTileHelper()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        { //Telerik Way

            Telerik.Windows.Controls.LiveTileHelper.CreateOrUpdateTile(new RadExtendedTileData()
            {
                Title = "Telerik Tile",
                VisualElement = this,
                BackContent = "Back Content",
                BackTitle = "Back title"
            }, new Uri("/MainPage.xaml", UriKind.RelativeOrAbsolute));
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        { //Standard Way
            var foundTile = ShellTile.ActiveTiles.FirstOrDefault(x => x.NavigationUri.ToString().Contains("Telerik"));

            if (foundTile == null)
            {
                var secondaryTile = new StandardTileData
                {
                    BackgroundImage = new Uri("Background.png", UriKind.Relative),
                    Title = "Telerik Tile",
                    Count = null
                };

                ShellTile.Create(new Uri("/Demos/LiveTileHelper.xaml", UriKind.Relative), secondaryTile);
            }
        }

        private void button3_Click(object sender, RoutedEventArgs e)
        { //NO UI Element Left Behind
            Telerik.Windows.Controls.LiveTileHelper.CreateOrUpdateTile(new RadExtendedTileData()
            {
                Title = "Telerik Tile UI Element",
                VisualElement = this.image1,
                BackContent = "Back Content",
                BackTitle = "Back title"
            }, new Uri("/MainPage.xaml", UriKind.RelativeOrAbsolute));
        }

        private void button4_Click(object sender, RoutedEventArgs e)
        { //Ellipse
            Telerik.Windows.Controls.LiveTileHelper.CreateOrUpdateTile(new RadExtendedTileData()
            {
                Title = "Telerik Tile Ellipse",
                VisualElement = this.ellipse,
                BackContent = "Back Content",
                BackTitle = "Back title"
            }, new Uri("/MainPage.xaml", UriKind.RelativeOrAbsolute));
        }
    }
}