﻿using System;
using System.Linq;
using System.Windows;
using Microsoft.Phone.Controls;
using Telerik.Windows.Controls;

namespace Q12012.WindowsPhone.Demos
{
    public partial class TrialFunctionality : PhoneApplicationPage
    {

        RadTrialFeatureReminder featureReminder;
        int FreeTapsCount; //Number of times they can tap the click button without displaying a warning!
        int FeatureUsages; //Counts the number of time they have used the feature. 

        public TrialFunctionality()
        {
            InitializeComponent();
            this.InitExample();            
        }

        private void InitExample()
        {

            button.IsEnabled = true;
            button.Content = "tap here";
          
            tryAgain.Visibility = Visibility.Collapsed;

           
            this.FreeTapsCount = 1;
            this.FeatureUsages = 3;

            this.featureReminder = new RadTrialFeatureReminder();
            this.featureReminder.FeatureId = 1;
            this.featureReminder.SimulateTrialForTests = true;
            this.featureReminder.UsageCount = 0; //Resets Usage Count on Load
            this.featureReminder.AllowedTrialUsageCount = FeatureUsages; 
            this.featureReminder.OccurrenceUsageCount = 1;
            this.featureReminder.FreeUsageCount = FreeTapsCount;
        }

        private void ChangeToExpiredState()
        {
            this.button.IsEnabled = false;
            this.button.Content = "expired";
           
            this.tryAgain.Visibility = Visibility.Visible;
        }

        private void TapHere(object sender, RoutedEventArgs e)
        {
            this.featureReminder.UsageCount++;
            if (this.FreeTapsCount > 0)
            {
                this.FreeTapsCount--;
            }
            this.featureReminder.Notify();

            if (this.FeatureUsages > 0)
            {
                this.FeatureUsages--;
            }

            if (this.FeatureUsages <= 0)
            {
                this.ChangeToExpiredState();
            }
        }

        private void TryAgain(object sender, RoutedEventArgs e)
        {
            this.InitExample();
        }   
    }
}